/*
                           Copyright (C) 1995 
             John R.Callahan, Sudhakar Ramakrishnan, Sun Wei.
	         Web Integrated Software Project 
                   Management and Metrics Tool
                           (WISE)

WISE [both binary and source] (hereafter, Software) is 
copyrighted by John R.Callahan, Sudhakar Ramakrishnan , Sun Wei and 
ownership remains with the authors.

The authors grant you (hereafter, Licensee), a license to use the Software
for academic, research and internal business purposes only, without a
fee.  Licensee may distribute the binary to third parties providing 
that the copyright notice and this statement appears on all copies and
that no charge is associated with such copies. 

Licensee may make derivative works.  However, if Licensee distributes
any derivative work based on or derived from the Software, then
Licensee will (1) notify the authors regarding its distribution of 
the derivative work, and (2) clearly notify users that such derivative 
work is a modified version and not the original WISE tool distributed 
by the authors.

Any Licensee wishing to make commercial use of the Software should
contact the authors to negotiate an appropriate license for such
commercial use.  Commercial use includes (1) integration of all or
part of the source code into a product for sale or license by or on
behalf of licensee to third parties, or (2) distribution of the binary
code or source code to third parties that need it to utilize a
commercial product sold or licensed by or on behalf of Licensee.

THE AUTHORS MAKE NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS 
SOFTWARE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR 
IMPLIED WARRANTY.  THE AUTHORS SHALL NOT BE LIABLE FOR ANY DAMAGES
SUFFERED BY USERS OF THIS SOFTWARE.

By using or copying this Software, Licensee agrees to abide by the
copyright law and all other applicable laws of the U.S., including but
not limited, to, export control laws, and the terms of this license.
The authors shall have the right to terminate this license immediately by
written notice upon Licensee's breach of, or non-compliance with, any
of its terms.  Licensee may be held legally responsible for any
copyright infringement that is caused, directly or indirectly, by
Licensee's failure to abide by the terms of this license.

Direct notices to:
	
	John R.Callahan 
	886 Chestnut Ridge Road
	Concurrent Engineering Research Center
	West Virginia University
	Morgantown, WV 26505
	USA

	phone:	(304) 293-7226
	email:	callahan@cerc.wvu.edu
*/

/* Bug fixes, changes, enhancements, Linas Vepstas,
 * December 1996, January, April, May 1997 
 * linas@fc.net
 */ 

#define WISEMAIN
#include <stdio.h>
#include <stdlib.h>
#include "cgi.h"
#include "msql.h"
#include "wise.h"

struct sortentry_t {
  char* fieldname;
  int order;
  struct sortentry_t* next;
};
typedef struct sortentry_t sortentry;
sortentry* sorthead = NULL;

char orderby[WISEBUFMAX];

void
sortby(char* field,int direction)
{
  sortentry* p;
  if(sorthead == NULL) {
    sorthead = (sortentry*)malloc(sizeof(sortentry));
    sorthead->fieldname = field;
    sorthead->order = direction;
    sorthead->next = NULL;
  } else {
    for(p=sorthead;p->next != NULL;p=p->next);
    p->next = (sortentry*)malloc(sizeof(sortentry));
    p = p->next;
    p->fieldname = field;
    p->order = direction;
    p->next = NULL;
  }
  return;
}

int
sorted(char* field)
{
  int i=1;
  sortentry* p;

  for(p=sorthead;p != NULL;p=p->next) {
    if(strcmp(field,p->fieldname) == 0) return p->order*i;
    i++;
  }
  return 0;
}

char sortvector[WISEBUFMAX];

void
dosortvector(char* except)
{
  sortentry *p;
  strcpy(sortvector,"");
  for(p=sorthead;p != NULL;p=p->next) {
    if(except == NULL || strcmp(p->fieldname,except) != 0) {
      if(p->order < 0) strcat(sortvector,"&descend=");
      else if(p->order > 0) strcat(sortvector,"&ascend=");
      strcat(sortvector,p->fieldname);
    }
  }
}

#ifdef NEWREPORT
char * wise_getfieldvalues (char *ru, char * projname, char *field ) {
  int ii;

  for (ii=0; NULL != wiseviewaccess[ii].project; ii++) { 
    if (0 == strcmp (projname, wiseviewaccess[ii].project)) {
      if (0 == strcmp (field, wiseviewaccess[ii].field)) {
        if (0x0 != wiseviewaccess[ii].values) {
          if (wise_playsrole (ru, wiseviewaccess[ii].role, projname)) {
             return (wiseviewaccess[ii].values);
          }
        }
      }
    }
  }
  return 0x0;
}

/* a replacement for wise_getaccess, to merge WPL access with user choices */
char*
wise_mergeaccess(char* ru, char* project, form_entry *parms)
{
  char *acc;
  char buf[WISEBUFMAX];
  char tmpbuf[WISEBUFMAX];
  form_entry *p;
  char * cgi_projname;
  char * cgi_fieldname;
  char * prev = 0x0;
  int started = 0;
  int rolling = 0;
  int chosen = 0;

  /* disable any table listings until user has made a choice out 
   * of the report genration menus */
  for(p=parms;p;p=p->next) {
    strcpy (tmpbuf, p->name);
    cgi_projname = strtok (tmpbuf, "_");
    cgi_fieldname = strtok (NULL, "_");
    if (cgi_fieldname) { 
      chosen=1;
      break;
    }
  }
  if (0 == chosen) {
    strcpy (buf, "project = 'f7dgpx7q'");
    return (buf);
  }

  /* get the query string, as derived from the wpl */
  acc = wise_getaccess(ru, project);
  strcpy (buf, "");
  strcat (buf, acc);
  if(strlen (buf)) started = 1;

  /* concatenate the user's choices */
  /* this requires support for nested boolean's which
   * is not available in msql v1.0 */
  prev = 0x0;
  for(p=parms;p;p=p->next) {
    strcpy (tmpbuf, p->name);
    cgi_projname = strtok (tmpbuf, "_");
    cgi_fieldname = strtok (NULL, "_");
    if (cgi_fieldname) {
      if (0==strcmp (project, cgi_projname)) {
         if (started) {
           if (!prev) {
             strcat (buf, " AND ( "); 
             rolling = 1;
           } else {
             if (0 == strcmp (prev, p->name)) {
               strcat (buf, " OR ");
             } else {
               strcat (buf, " ) AND ( "); 
               rolling = 1;
             }
           }
         }

         started = 1;
         strcat (buf, cgi_fieldname);
         strcat (buf, " = \'");
         strcat (buf, p->val);
         strcat (buf, "\' ");

         prev = p->name;
      }
    }
  }

  if (rolling) strcat (buf, " ) "); 

  return buf;
}

#endif /* NEWREPORT */

void
sql_main(char* projname,char* ru,char* issueno, form_entry *parms)
{
  int i,j,k,sock,sorder;
  int ii;
  m_result *result;
  m_row row;
  char buf[WISEBUFMAX];
  char fields[WISEBUFMAX];
  char* access;
  char* project[WISEBUFMAX];
  WiseTDLField *wisetdlfield;
  char* db;
  char* dbhost;
  form_entry *p;
    
  if((db = wise_getprojdb(projname)) == NULL) {
    printf("<H1>Could not find project database name!</H1>");
    return;
  }
  if((dbhost = wise_getprojhost(projname)) == NULL) {
    printf("<H1>Could not find project database host!</H1>");
    return;
  }
  wise_setprojport(projname);
  if((sock = msqlConnect(dbhost)) < 0) {
    printf("<H1>Connect error: %s</H1>",msqlErrMsg);
    return;
  }
  if(msqlSelectDB(sock,db) < 0) {
    printf("<H1>WISE server currently unavailable<H1>");
    printf("<H2>Please try again later</H2>");
    return;
  }
  strcpy(fields,"");
  /* find tdl array for the project */
  if((wisetdlfield = wise_getprojecttdl(projname)) == NULL) {
    printf("<H1>Could not find project name</H1>");
    return;
  }
  for(i=0;wisetdlfield[i].field != NULL;i++) {
    if(WISEDEBUG) printf("field[%d] = %s<BR>\n",i,wisetdlfield[i].field);
    if(strlen(fields) > 0) strcat(fields,",");
    strcat(fields,wisetdlfield[i].field);
  }
  if(WISEDEBUG) printf("fields = %s<BR>\n",fields);
  wise_getprojects(ru,project);
  if(WISEDEBUG) for(k=0;project[k] != NULL;k++)
    printf("project = %s<BR>\n",project[k]);
  for(k=0;project[k] != NULL;k++) {
    if(strcmp(project[k],projname) == 0) {
      if(WISEDEBUG) printf("project = %s<BR>\n",project[k]);
#ifdef NEWREPORT
      access = wise_mergeaccess(ru,project[k], parms);
#else 
      access = wise_getaccess(ru,project[k]);
#endif /* NEWREPORT */
      if(WISEDEBUG) printf("access = %s<BR>\n",access);
      if((strlen(fields) > 0) && (strlen(access) > 0)) {
	sprintf(buf,"select issueno,project,%s from %s where %s %s",fields,project[k],access,orderby);
      } else if(strlen(fields) > 0) {
	sprintf(buf,"select issueno,project,%s from %s %s",fields,project[k],orderby);
      } else {
	printf("No items found<BR>\n");
	msqlClose(sock);
	return;
      }
      if(WISEDEBUG) printf("query = %s<BR>",buf);
      if(msqlQuery(sock,buf) < 0) {
	printf("<H1>Query error: %s</H1>",msqlErrMsg);
	return;
      }
      result = msqlStoreResult();
      printf("<table border colspec=\"L9");
      for(i=0;wisetdlfield[i].field != NULL;i++) {
	printf(" L%d",wisetdlfield[i].fieldwidth);
      }
      printf("\">\n<tr>");
      dosortvector("issueno");
      if((sorder = sorted("issueno")) > 0) {
	printf("<td><A HREF=\"http://%s:%s/%s?project=%s&descend=issueno%s",
	       WISEHOST,WISEPORT,WISE_TDL,projname,sortvector);
#ifdef NEWREPORT
        wise_print_query_opts (projname, parms); 
#endif /* NEWREPORT */
	printf("\">issueno+%-1.1d</A>\n",sorder);
      } else if (sorder < 0) {
	printf("<td><A HREF=\"http://%s:%s/%s?project=%s%s",
	       WISEHOST,WISEPORT,WISE_TDL,projname,sortvector);
#ifdef NEWREPORT
        wise_print_query_opts (projname, parms); 
#endif /* NEWREPORT */
	printf("\">issueno-%-1.1d</A>\n", -sorder);
      } else {
	printf("<td><A HREF=\"http://%s:%s/%s?project=%s&ascend=issueno%s",
	       WISEHOST,WISEPORT,WISE_TDL,projname,sortvector);
#ifdef NEWREPORT
        wise_print_query_opts (projname, parms); 
#endif /* NEWREPORT */
	printf("\">issueno  </A>\n");
      }

      for(i=0;wisetdlfield[i].field != NULL;i++) {
	dosortvector(wisetdlfield[i].field);
	if((sorder = sorted(wisetdlfield[i].field)) > 0) {
	  printf("<td><A HREF=\"http://%s:%s/%s?project=%s",
		  WISEHOST,WISEPORT,WISE_TDL,projname);
#ifdef NEWREPORT
          wise_print_query_opts (projname, parms); 
#endif /* NEWREPORT */
	  sprintf(buf,"&descend=%%s%s\">%%-%d.%ds+%-1.1d</A>\n",
		  sortvector,wisetdlfield[i].fieldwidth, wisetdlfield[i].fieldwidth,sorder);
	} else if (sorder < 0) {
	  printf("<td><A HREF=\"http://%s:%s/%s?project=%s",
		  WISEHOST,WISEPORT,WISE_TDL,projname);
#ifdef NEWREPORT
          wise_print_query_opts (projname, parms); 
#endif /* NEWREPORT */
	  sprintf(buf,"%s\">%%-%d.%ds-%-1.1d</A>\n",
		  sortvector,wisetdlfield[i].fieldwidth,wisetdlfield[i].fieldwidth,-sorder);
	} else {
	  printf("<td><A HREF=\"http://%s:%s/%s?project=%s",
		  WISEHOST,WISEPORT,WISE_TDL,projname);
#ifdef NEWREPORT
          wise_print_query_opts (projname, parms); 
#endif /* NEWREPORT */
	  sprintf(buf,"&ascend=%%s%s\">%%-%d.%ds  </A>\n",
		  sortvector,wisetdlfield[i].fieldwidth,wisetdlfield[i].fieldwidth);
	}
	printf(buf,wisetdlfield[i].field,wisetdlfield[i].field);
      }
      printf("\n");
      while((row = msqlFetchRow(result)) != NULL) {
	dosortvector(NULL);
 	printf("\n<tr><td><A NAME=\"issue%s\" 
             HREF=\"http://%s:%s/%s?project=%s&issueno=%s",
             row[0],WISEHOST,WISEPORT,WISE_VIEW,row[1],row[0]);
#ifdef NEWREPORT
        wise_print_query_opts (projname, parms); 
#endif /* NEWREPORT */
 	printf("%s\">", sortvector);
	if(issueno != NULL && strcmp(issueno,row[0]) == 0) {
	  printf("<blink>%-9.9s</blink></A>",row[0]);
	} else {
	  printf("%-9.9s</A>\n",row[0]);
	}
	for(i=2;i < msqlNumFields(result);i++) {
	  sprintf(buf,"<td>%%-%d.%ds",
	      wisetdlfield[i-2].fieldwidth+2,wisetdlfield[i-2].fieldwidth+2);
	  printf(buf,row[i]);
        }
      }
      msqlFreeResult(result);
    }

#ifdef NEWREPORT
    printf("<tr><td>"); 
    for(i=0;wisetdlfield[i].field != NULL;i++) {
      char *fieldvalues, *fieldname;
      char tmpbuf[WISEBUFMAX];

      fieldname = wisetdlfield[i].field;
      printf("\n<td>");
      fieldvalues = wise_getfieldvalues (ru, projname, fieldname);
      if (fieldvalues) {
        printf("Show %s values\n", fieldname);
   
        printf ("<FORM ACTION=http://%s:%s/%s METHOD=POST>\n", 
                 WISEHOST, WISEPORT, WISE_TDL);
        /* printf ("<INPUT TYPE=hidden NAME=project VALUE=\"%s\">\n", projname); */ 

        printf ("<SELECT MULTIPLE SIZE=10 NAME=\"%s_%s\">\n", projname, fieldname);
        strcpy (tmpbuf, projname);
        strcat (tmpbuf, "_");
        strcat (tmpbuf, fieldname);

        /* print hidden only if doesnt match */
        for(p=parms;p;p=p->next) {
          if (strcmp (tmpbuf, p->name)) {
            printf ("<INPUT TYPE=hidden NAME=%s VALUE=\"%s\">\n", p->name, p->val);
          }
        }

        strcpy (buf, fieldvalues);
        fieldvalues = strtok (buf, WISESEPCHARS);
   
        while (fieldvalues) {
          printf ("<OPTION value=\"%s\"", fieldvalues);

          for(p=parms;p;p=p->next) {
            if (0 == strcmp (tmpbuf, p->name)) {
              if (0 == strcmp (fieldvalues, p->val)) {
                printf (" SELECTED ");
              }
            }
          }

          printf (">%s\n", fieldvalues);
          fieldvalues = strtok (NULL, WISESEPCHARS);
        }
   
        printf ("</SELECT><br>\n");
        printf ("<INPUT TYPE=SUBMIT VALUE=\"show\">\n");
        printf ("</FORM>\n");
      }
    }
#endif /* NEWREPORT */
  }
  printf("</table>\n");
  msqlClose(sock);
}



int
main()
{
  char* ru;
  char* project=NULL;
  char* issueno=NULL;
  form_entry *parms,*p;
  int status = 0;
  cgi_info ci;

  /* initialize orderby array -- bugfix linas */
  orderby[0] = 0x0;

  /* display MIME header */
  printf("Content-type: text/html\n\n");

  /* get the name of the remote user */
  if((ru = getenv("REMOTE_USER")) == NULL) {
    printf("<H1>Error: cannot get remote user name</H1></html>");
    return 0;
  }

  /* load command line parameters */
  status = get_cgi_info( &ci );
  if (!status) {
    printf("<h1>Error: Processing CGI info</h1></html>");
    return 0;
  }

  /* build and submit the update */
  parms = get_form_entries( &ci);
  for(p=parms;p;p=p->next) {
    if(strlen(p->name) > WISEBUFMAX || strlen(p->val) > WISEBUFMAX) {
      printf("<h1>Error: Submission strings too long.  Try again...</h1></html>");
      return 0;
    }
    if(strcmp(p->name,"ascend") == 0) {
      sortby(p->val,1);
      if(strlen(orderby) > 0) {
	strcat(orderby,",");
	strcat(orderby,p->val);
      } else {
	strcpy(orderby,"order by ");
	strcat(orderby,p->val);
      }
    } else if(strcmp(p->name,"descend") == 0) {
      sortby(p->val,-1);
      if(strlen(orderby) > 0) {
	strcat(orderby,",");
	strcat(orderby,p->val);
	strcat(orderby," DESC");
      } else {
	strcpy(orderby,"order by ");
	strcat(orderby,p->val);
	strcat(orderby," DESC");
      }
    } else if(strcmp(p->name,"issue") == 0) {
      issueno = p->val;
    } else if(strcmp(p->name,"project") == 0) {
      project = p->val;
    }
  }

  if(project == NULL) {

    int i;
    char* projarray[WISEBUFMAX];

    /* define and display the HTML page */
    printf("<!DOCTYPE HTML SYSTEM \"html.dtd\">\n\
        <HTML>\n\
        <HEAD>\n\
        <TITLE>Project List for %s</TITLE>\n\
        </HEAD>\n\
        \
        <BODY BACKGROUND=\"%s\" TEXT=\"000000\"\
        LINK=\"0000ff\" VLINK=\"0000ff\">\n\
        <BASEFONT SIZE=4>\n\
        <center>\n\
        <table cellpadding=1>\n\
        <tr><td rowspan=4><table cellpadding=5><tr><td>\
        <IMG SRC=\"%s\" ALIGN=center></td></tr></table></td></tr>\n\
        <tr><td><H2>%s</H2></td></tr>\n\
        </table>\n\
        ",ru,WISEBKGND,WISEORGIMAGE,WISEORGNAME);

    printf("<H1>List of Projects</H1><BR>\n");
    printf("The following is a list of projects on which you (%s) are listed as",ru);
    printf("a participant.  Please select one of these projects to view your To-Do List");
    printf("for that project.  You may also wish to view metrics for the projects listed below.<BR><HR><BR>");
    printf("<UL>\n");

    wise_getprojects(ru,projarray);
    printf("<H2>Projects for %s</H2><BR>",ru);
    for(i=0;projarray[i] != NULL;i++) {
      printf("<LI>");
      printf("<H3><A HREF=\"http://%s:%s/%s?project=%s\">To-Do List for %s</A></H3><BR>",WISEHOST,WISEPORT,WISE_TDL,
	     projarray[i],wise_getprojlabel(projarray[i]));
    }
    printf("<H2>Metrics for %s</H2><BR>",ru);
    for(i=0;projarray[i] != NULL;i++) {
      printf("<LI>");
      printf("<H3><A HREF=\"http://%s:%s/%s/%s-metrics.html\">Metrics for %s</A></H3><BR>",WISEHOST,WISEPORT,WISEMETRICS,
	     projarray[i],wise_getprojlabel(projarray[i]));
    }

    printf("</UL>");
    printf ("<HR><center><em>A WISE application &copy 1995 <A HREF=\"http://research.ivv.nasa.gov/\">West Virginia University</A></em></center><HR>");
    printf ("</body></html>\n");

  } else {

    int i,first;
    char* projnames[WISEBUFMAX];

    if(strlen(orderby) == 0) {
      strcpy(orderby,"order by issueno DESC");
    }

    /* define and display the HTML page */
    printf("<!DOCTYPE HTML SYSTEM \"html.dtd\">\
        <HTML>\n\
        <HEAD>\n\
        <TITLE>%s: To-Do List for %s</TITLE>\n\
        </HEAD>\n\
        \
        <BODY BACKGROUND=\"%s\" TEXT=\"000000\"\
        LINK=\"0000ff\" VLINK=\"0000ff\">\n\
        <BASEFONT SIZE=4>\n\
        <center>\n\
        <table>\n\
        <tr><td><IMG SRC=\"%s\" ALIGN=center><td><center><H2>%s</H2>\n<\center>\n\
        </table>\n\
        ",wise_getprojlabel(project),ru,WISEBKGND,wise_getprojimage(project),wise_getprojlabel(project));

    printf("<BR>\n");
    /* print actions */
    dosortvector(NULL);
    wise_printtdlactions(ru,project,sortvector, parms);

    /* print metrics */
    printf("<A HREF=\"http:/%s/%s-metrics.html\"><B>METRICS</B></A>\n | ",
	   WISEMETRICS,project,wise_getprojlabel(project));

    /* print projects */
    wise_getprojects(ru,projnames);
    for(i=0;projnames[i] != NULL;i++) {
      if(strcmp(projnames[i],project) != 0) {
	printf("<A HREF=\"http://%s:%s/%s?project=%s\"><B>%s</B></A>\n | ",
	       WISEHOST,WISEPORT,WISE_TDL,projnames[i],
               wise_getprojlabel(projnames[i]));
      } else {
	printf("<A HREF=\"http://%s:%s/wise/docs/%s.html\"><B>%s Project Help</B></A>\n | ",
	       WISEHOST,WISEPORT,project,
               wise_getprojlabel(project));
      }
    }
    printf(" <A HREF=\"http://%s:%s", WISEHOST, WISEPORT);
    printf("/research.ivv.nasa.gov/projects/WISE/wise-help.html\">\n");
    printf ("<B>Generic Help</B></A>\n<BR><BR>\n");

    /* display all issues as hyper links */
    sql_main(project,ru,issueno, parms);

    /* print page tail */
    printf("</center>\n");
    printf ("<HR><center><em>A WISE application &copy 1995 <A HREF=\"http://research.ivv.nasa.gov/\">West Virginia University</A></em></center><HR>\n");
    printf ("</body></html>\n");

  }

  free_form_entries(parms);

  return 0;
}

